/*
Pierre Hébert - Sketch - 2014
This software is provided as is. Public domain.
You are free to use, duplicate and modify it without restriction.
*/
var MY_PKG = "net.pierrox.lightning_launcher.llscript.clock";


// install (or update) a script given its id in the package, and its clear name in the launcher data
function installScript(id, name) {
    // load the script (if any) among the existing ones
    var script = LL.getScriptByName(name);

    // load the touch handler from the package
    var script_text = LL.loadRawResource(MY_PKG, id);

    if(script == null) {
        // script not found: install it
        script = LL.createScript(name, script_text , 0);
    } else {
        // the script already exists: update its text
        script.setText(script_text);
    }

    return script;
}

var script_resumed = installScript("clock_resumed", "Clock / resumed handler");
var script_paused = installScript("clock_paused", "Clock / paused handler");

// create the clock item: a dummy shortcut, label and icon hidden, draw its background
var w = prompt("Clock width (columns) ?", 2);
var h = prompt("Clock height (rows) ?", 2);

var d = LL.getCurrentDesktop();
// debug code d.removeItem(d.getItemByLabel("clock"));

var clock = d.addShortcut("clock", new Intent(), 0, 0);
clock.setCell(0, 0, w, h, true);
var ed = clock.getProperties().edit();
ed.setBoolean("s.iconVisibility", false);
ed.setBoolean("s.labelVisibility", false);
ed.getBox("i.box").setAlignment("CENTER", "TOP");
ed.setEventHandler("i.resumed", EventHandler.RUN_SCRIPT, script_resumed.getId());
ed.setEventHandler("i.paused", EventHandler.RUN_SCRIPT, script_paused.getId());
ed.setEventHandler("i.tap", EventHandler.NOTHING, null);
ed.commit();

var bg = LL.createImage(512, 512);
clock.setBoxBackground(bg, "n");
clock.getBoxBackground("n").save();

// hack: the resumed event is triggered as soon as the item is created, hence before the "i.resumed" event handler is set
// the following lines will effectively pause and resume the launcher, and start the clock
var intent = new Intent();
intent.setClassName( "net.pierrox.lightning_launcher_extreme", "net.pierrox.lightning_launcher.activities.Dashboard");
intent['putExtra(java.lang.String,int)']("p", d.getId());﻿
LL.startActivity(intent);